=== debian/changelog ===
argagg (0.4.6-6) unstable; urgency=medium

  * Orphan package

  [ Debian Janitor ]
  * Set upstream metadata fields

  [ Didier Raboud ]
  * S-V: Update to 4.6.0 without changes needed
  * Run wrap-and-sort -baskt
  * Fix MIT/Expat license name, thanks to cme
  * Bump debhelper compat to 13

 -- Didier Raboud <odyx@debian.org>  Wed, 01 Sep 2021 15:53:51 +0200

argagg (0.4.6-5) unstable; urgency=medium

  * Bump debhelper from old 11 to 12.
  * Bump S-V to 4.4 without changes needed
  * Convert patch-queue to git debrebase

 -- Didier Raboud <odyx@debian.org>  Fri, 20 Sep 2019 16:40:13 +0200

argagg (0.4.6-4) unstable; urgency=medium

  * Cleanup d/control thanks to `cme update dpkg-control`
  * Update Vcs-* for the move to Salsa
  * Bump debhelper compat to 11

 -- Didier Raboud <odyx@debian.org>  Fri, 23 Feb 2018 20:52:18 +0100

argagg (0.4.6-3) unstable; urgency=medium

  [ Chris Lamb ]
  * Make the build reproducible (Closes: #879569)

 -- Didier Raboud <odyx@debian.org>  Mon, 23 Oct 2017 08:06:46 +0200

argagg (0.4.6-2) unstable; urgency=medium

  * Mark argagg-dev Multi-Arch: foreign
  * Add gbp.conf

 -- Didier Raboud <odyx@debian.org>  Sun, 22 Oct 2017 17:53:00 +0200

argagg (0.4.6-1) unstable; urgency=low

  * Initial release. (Closes: #878641)

 -- Didier Raboud <odyx@debian.org>  Fri, 20 Oct 2017 13:00:01 +0200
