## argagg 0.4.7

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,23 @@
 cmake_minimum_required( VERSION 2.8 )
 project( argagg CXX )
+
+add_library(
+  argagg
+  INTERFACE
+)
+
+add_library(
+  argagg::argagg
+  ALIAS
+  argagg
+)
+
+target_include_directories(
+  argagg
+  INTERFACE
+  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
+  $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
+)
 
 option(
   ARGAGG_BUILD_EXAMPLES
@@ -21,7 +39,7 @@
 
 set(
   ARGAGG_TEST_COMPILE_FLAGS
-  "-g -Wall -Wextra -Wpedantic -Werror -std=c++11"
+  "-g -Wall -Wextra -Wpedantic -Wsign-conversion -Werror -std=c++11"
   CACHE STRING "Compiler flags for all project targets"
 )
 
@@ -68,7 +86,7 @@
     joinargs
     PROPERTIES
       COMPILE_FLAGS "${ARGAGG_TEST_COMPILE_FLAGS}"
-      INCLUDE_DIRECTORIES "${CMAKE_CURRENT_SOURCE_DIR}/include"
+      LINK_LIBRARIES argagg
       RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin"
   )
 
@@ -77,7 +95,7 @@
     gengetopt_main1
     PROPERTIES
       COMPILE_FLAGS "${ARGAGG_TEST_COMPILE_FLAGS}"
-      INCLUDE_DIRECTORIES "${CMAKE_CURRENT_SOURCE_DIR}/include"
+      LINK_LIBRARIES argagg
       RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin"
       OUTPUT_NAME sample1
   )
@@ -87,7 +105,40 @@
 # Build and register the unit tests if configured to.
 if( ARGAGG_BUILD_TESTS )
   enable_testing()
-  add_executable( argagg_test "test/test.cpp" )
+
+  list( APPEND ARGAGG_TEST_SOURCES "test/test.cpp" )
+  list( APPEND ARGAGG_TEST_SOURCES "test/test_csv.cpp" )
+
+  find_path( OPENCV_INCLUDE_DIR "opencv2/opencv.hpp" )
+  find_library( OPENCV_CORE_LIBRARY opencv_core )
+  if( OPENCV_INCLUDE_DIR AND OPENCV_CORE_LIBRARY )
+    list( APPEND ARGAGG_TEST_SOURCES "test/test_opencv.cpp" )
+    list( APPEND ARGAGG_TEST_INCLUDE_DIRS ${OPENCV_INCLUDE_DIR} )
+    list( APPEND ARGAGG_TEST_LIB_DEPS ${OPENCV_CORE_LIBRARY} )
+  else()
+    message( "Unable to find OpenCV, disabling test_opencv.cpp" )
+  endif()
+
+  add_executable( argagg_test ${ARGAGG_TEST_SOURCES} )
+
+  list( LENGTH ARGAGG_TEST_INCLUDE_DIRS ARGAGG_TEST_INCLUDE_DIRS_LENGTH )
+  if( ARGAGG_TEST_INCLUDE_DIRS_LENGTH GREATER 0 )
+    target_include_directories(
+      argagg_test
+      PRIVATE
+      ${ARGAGG_TEST_INCLUDE_DIRS}
+    )
+  endif()
+
+  list( LENGTH ARGAGG_TEST_LIB_DEPS ARGAGG_TEST_LIB_DEPS_LENGTH )
+  if( ARGAGG_TEST_LIB_DEPS_LENGTH GREATER 0 )
+    target_link_libraries(
+      argagg_test
+      PRIVATE
+      ${ARGAGG_TEST_LIB_DEPS}
+    )
+  endif()
+
   set_target_properties(
     argagg_test
     PROPERTIES
@@ -118,7 +169,7 @@
     "${CMAKE_CURRENT_SOURCE_DIR}/include/*"
     "${CMAKE_CURRENT_SOURCE_DIR}/test/*"
   )
-  
+
   # Like the version.hpp header file we're going to replace some CMake variables
   # in the doxygen configuration with actual values.
   configure_file(
@@ -126,7 +177,7 @@
     ${CMAKE_BINARY_DIR}/doxygen.cfg
     @ONLY
   )
-  
+
   # Now we add a command for CMake to run to generate documentation.
   add_custom_command(
     # We tell CMake that this command will generate the `html` and `xml`
@@ -149,7 +200,7 @@
       ${CMAKE_BINARY_DIR}/doxygen.cfg
       ${DOC_INPUTS}
   )
-  
+
   # This creates an "empty target" named "docs" that doesn't produce output, but
   # depends on the generated documentation. The result is we can run "make docs"
   # and it behaves the way we expect. It also doesn't regenerate documentation if
@@ -160,7 +211,7 @@
       "${CMAKE_BINARY_DIR}/share/doc/${PROJECT_NAME}/html"
       "${CMAKE_BINARY_DIR}/share/doc/${PROJECT_NAME}/xml"
   )
-  
+
   # Finally set up an installation target for the documentation.
   install(
     DIRECTORY "${CMAKE_BINARY_DIR}/share/"
