=== debian/changelog ===
argagg (0.4.7-4) unstable; urgency=medium

  * QA upload.
  * debian/copyright: Update packaging copyright information.
  * debian/tests/*: Create autopkgtest.

 -- Henrique Romaniuk Ramalho <henriqueramalho@alunos.utfpr.edu.br>  Tue, 28 Oct 2025 18:50:38 -0300

argagg (0.4.7-3) unstable; urgency=medium

  * QA upload.
  * Bump CMake policy version (Closes: #1112706)

 -- Timo Röhling <roehling@debian.org>  Wed, 24 Sep 2025 21:28:58 +0200

argagg (0.4.7-2) unstable; urgency=medium

  * QA upload.
  * Add patch to avoid errors on casting unsigned/signed 
    (Closes: #1103065)

 -- Andreas Rönnquist <gusnan@debian.org>  Fri, 02 May 2025 12:59:03 +0200

argagg (0.4.7-1) unstable; urgency=medium

  * QA upload.
  * New upstream release.
  * debian/patches: Refresh patches.
  * debian/gbp.conf: Fix master branch name.

 -- Boyuan Yang <byang@debian.org>  Fri, 27 Jan 2023 13:13:35 -0500

argagg (0.4.6-7) unstable; urgency=medium

  * QA upload.

  [ Didier Raboud ]
  * Add Salsa CI configuration

 -- Jelmer Vernooĳ <jelmer@debian.org>  Wed, 25 May 2022 18:58:28 +0100
