=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
  debhelper-compat (= 13),
  doctest-dev,
  doxygen,
-Standards-Version: 4.6.0
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/debian/argagg
 Vcs-Git: https://salsa.debian.org/debian/argagg.git
 Homepage: https://github.com/vietjtnguyen/argagg
