=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/argagg-$1\.tar\.gz/ \
  https://github.com/vietjtnguyen/argagg/tags .*/v?(\d\S+)\.tar\.gz
